Index: /palm/trunk/SOURCE/print_1d.f90
===================================================================
--- /palm/trunk/SOURCE/print_1d.f90	(revision 1319)
+++ /palm/trunk/SOURCE/print_1d.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -35,7 +41,4 @@
 ! RCS Log replace by Id keyword, revision history cleaned up
 !
-! Revision 1.11  2006/02/23 12:50:43  raasch
-! Preliminary no output of time-averaged data
-!
 ! Revision 1.1  1997/09/19 07:45:22  raasch
 ! Initial revision
@@ -47,16 +50,30 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  zu, zw
+
+    USE control_parameters,                                                    &
+        ONLY:  run_description_header, simulated_time_chr
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point
+
+    USE indices,                                                               &
+        ONLY:  nzb, nzt
+
+    USE kinds
+
     USE pegrid
-    USE statistics
+
+    USE statistics,                                                            &
+        ONLY:  flow_statistics_called, hom, region, statistic_regions
 
     IMPLICIT NONE
 
 
-    CHARACTER (LEN=20) ::  period_chr
-    INTEGER ::  k, sr
+    CHARACTER (LEN=20) ::  period_chr  !:
+
+    INTEGER(iwp) ::  k   !:
+    INTEGER(iwp) ::  sr  !:
 
 
Index: /palm/trunk/SOURCE/production_e.f90
===================================================================
--- /palm/trunk/SOURCE/production_e.f90	(revision 1319)
+++ /palm/trunk/SOURCE/production_e.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -50,55 +56,4 @@
 ! TKE production by buoyancy can be switched off in case of runs with pure
 ! neutral stratification
-!
-! 759 2011-09-15 13:58:31Z raasch
-! initialization of u_0, v_0
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
-!
-! 449 2010-02-02 11:23:59Z raasch
-! test output from rev 410 removed
-!
-! 388 2009-09-23 09:40:33Z raasch
-! Bugfix: wrong sign in buoyancy production of ocean part in case of not using
-!         the reference density (only in 3D routine production_e)
-! Bugfix to avoid zero division by km_neutral
-!
-! 208 2008-10-20 06:02:59Z raasch
-! Bugfix concerning the calculation of velocity gradients at vertical walls 
-! in case of diabatic conditions
-!
-! 187 2008-08-06 16:25:09Z letzel
-! Change: add 'minus' sign to fluxes obtained from subroutine wall_fluxes_e for
-! consistency with subroutine wall_fluxes
-!
-! 124 2007-10-19 15:47:46Z raasch
-! Bugfix: calculation of density flux in the ocean now starts from nzb+1
-!
-! 108 2007-08-24 15:10:38Z letzel
-! Bugfix: wrong sign removed from the buoyancy production term in the case
-! use_reference = .T.,
-! u_0 and v_0 are calculated for nxr+1, nyn+1 also (otherwise these values are
-! not available in case of non-cyclic boundary conditions)
-! Bugfix for ocean density flux at bottom
-!
-! 97 2007-06-21 08:23:15Z raasch
-! Energy production by density flux (in ocean) added
-! use_pt_reference renamed use_reference
-!
-! 75 2007-03-22 09:54:05Z raasch
-! Wall functions now include diabatic conditions, call of routine wall_fluxes_e,
-! reference temperature pt_reference can be used in buoyancy term,
-! moisture renamed humidity
-!
-! 37 2007-03-01 08:33:54Z raasch
-! Calculation extended for gridpoint nzt, extended for given temperature /
-! humidity fluxes at the top, wall-part is now executed in case that a
-! Prandtl-layer is switched on (instead of surfaces fluxes switched on)
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.21  2006/04/26 12:45:35  raasch
-! OpenMP parallelization of production_e_init
 !
 ! Revision 1.1  1997/09/19 07:45:35  raasch
@@ -113,12 +68,16 @@
 !------------------------------------------------------------------------------!
 
-    USE wall_fluxes_mod
+    USE wall_fluxes_mod,                                                       &
+        ONLY:  wall_fluxes_e, wall_fluxes_e_acc
+
+    USE kinds
 
     PRIVATE
     PUBLIC production_e, production_e_acc, production_e_init
 
-    LOGICAL, SAVE ::  first_call = .TRUE.
-
-    REAL, DIMENSION(:,:), ALLOCATABLE, SAVE ::  u_0, v_0
+    LOGICAL, SAVE ::  first_call = .TRUE.  !:
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, SAVE ::  u_0  !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, SAVE ::  v_0  !:
 
     INTERFACE production_e
@@ -143,20 +102,51 @@
     SUBROUTINE production_e
 
-       USE arrays_3d
-       USE cloud_parameters
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, dd2zu, kh, km, pt, q, ql, qsws, qswst, rho, shf,       &
+                  tend, tswst, u, v, vpt, w
+
+       USE cloud_parameters,                                                   &
+           ONLY:  l_d_cp, l_d_r, pt_d_t, t_d_pt
+
+       USE control_parameters,                                                 &
+           ONLY:  cloud_droplets, cloud_physics, g, humidity, kappa, neutral,  &
+                  ocean, prandtl_layer, pt_reference, rho_reference,           &
+                  use_single_reference_value, use_surface_fluxes,              &
+                  use_top_fluxes
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, dx, ddy, dy, wall_e_x, wall_e_y
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_diff_s_inner,                   &
+                   nzb_diff_s_outer, nzb_s_inner, nzt, nzt_diff
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-
-       REAL    ::  def, dudx, dudy, dudz, dvdx, dvdy, dvdz, dwdx, dwdy, dwdz, &
-                   k1, k2, km_neutral, theta, temp
-
-!       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  usvs, vsus, wsus, wsvs
-       REAL, DIMENSION(nzb:nzt+1) ::   usvs, vsus, wsus, wsvs
+       INTEGER(iwp) ::  i           !:
+       INTEGER(iwp) ::  j           !:
+       INTEGER(iwp) ::  k           !:
+
+       REAL(wp)     ::  def         !:
+       REAL(wp)     ::  dudx        !:
+       REAL(wp)     ::  dudy        !:
+       REAL(wp)     ::  dudz        !:
+       REAL(wp)     ::  dvdx        !:
+       REAL(wp)     ::  dvdy        !:
+       REAL(wp)     ::  dvdz        !:
+       REAL(wp)     ::  dwdx        !:
+       REAL(wp)     ::  dwdy        !:
+       REAL(wp)     ::  dwdz        !:
+       REAL(wp)     ::  k1          !:
+       REAL(wp)     ::  k2          !:
+       REAL(wp)     ::  km_neutral  !:
+       REAL(wp)     ::  theta       !:
+       REAL(wp)     ::  temp        !:
+
+!       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  usvs, vsus, wsus, wsvs
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  usvs  !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  vsus  !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsus  !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsvs  !:
 
 !
@@ -166,8 +156,8 @@
 !--    Therefore, ij-Version is called further below within the ij-loops.
 !       IF ( topography /= 'flat' )  THEN
-!          CALL wall_fluxes_e( usvs, 1.0, 0.0, 0.0, 0.0, wall_e_y )
-!          CALL wall_fluxes_e( wsvs, 0.0, 0.0, 1.0, 0.0, wall_e_y )
-!          CALL wall_fluxes_e( vsus, 0.0, 1.0, 0.0, 0.0, wall_e_x )
-!          CALL wall_fluxes_e( wsus, 0.0, 0.0, 0.0, 1.0, wall_e_x )
+!          CALL wall_fluxes_e( usvs, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, wall_e_y )
+!          CALL wall_fluxes_e( wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, wall_e_y )
+!          CALL wall_fluxes_e( vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, wall_e_x )
+!          CALL wall_fluxes_e( wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, wall_e_x )
 !       ENDIF
 
@@ -240,7 +230,7 @@
 !--                         has been available
                       CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                          usvs, 1.0, 0.0, 0.0, 0.0 )
+                                          usvs, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp )
                       CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                          wsvs, 0.0, 0.0, 1.0, 0.0 )
+                                          wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp )
                       km_neutral = kappa * ( usvs(k)**2 + wsvs(k)**2 )**0.25 * &
                                    0.5 * dy 
@@ -270,7 +260,7 @@
 !--                         has been available
                       CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                          vsus, 0.0, 1.0, 0.0, 0.0 )
+                                          vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp )
                       CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                          wsus, 0.0, 0.0, 0.0, 1.0 )
+                                          wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp )
                       km_neutral = kappa * ( vsus(k)**2 + wsus(k)**2 )**0.25 * &
                                    0.5 * dx
@@ -716,19 +706,51 @@
     SUBROUTINE production_e_acc
 
-       USE arrays_3d
-       USE cloud_parameters
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, dd2zu, kh, km, pt, q, ql, qsws, qswst, rho, shf,       &
+                  tend, tswst, u, v, vpt, w
+
+       USE cloud_parameters,                                                   &
+           ONLY:  l_d_cp, l_d_r, pt_d_t, t_d_pt
+
+       USE control_parameters,                                                 &
+           ONLY:  cloud_droplets, cloud_physics, g, humidity, kappa, neutral,  &
+                  ocean, prandtl_layer, pt_reference, rho_reference,           &
+                  topography, use_single_reference_value, use_surface_fluxes,  &
+                  use_top_fluxes
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, dx, ddy, dy, wall_e_x, wall_e_y
+
+       USE indices,                                                            &
+           ONLY:  i_left, i_right, j_north, j_south, nxl, nxr, nys, nyn, nzb,  &
+                  nzb_diff_s_inner, nzb_diff_s_outer, nzb_s_inner, nzt,        &
+                  nzt_diff
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-
-       REAL    ::  def, dudx, dudy, dudz, dvdx, dvdy, dvdz, dwdx, dwdy, dwdz, &
-                   k1, k2, km_neutral, theta, temp
-
-       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  usvs, vsus, wsus, wsvs
+       INTEGER(iwp) ::  i           !:
+       INTEGER(iwp) ::  j           !:
+       INTEGER(iwp) ::  k           !:
+
+       REAL(wp)     ::  def         !:
+       REAL(wp)     ::  dudx        !:
+       REAL(wp)     ::  dudy        !:
+       REAL(wp)     ::  dudz        !:
+       REAL(wp)     ::  dvdx        !:
+       REAL(wp)     ::  dvdy        !:
+       REAL(wp)     ::  dvdz        !:
+       REAL(wp)     ::  dwdx        !:
+       REAL(wp)     ::  dwdy        !:
+       REAL(wp)     ::  dwdz        !:
+       REAL(wp)     ::  k1          !:
+       REAL(wp)     ::  k2          !:
+       REAL(wp)     ::  km_neutral  !:
+       REAL(wp)     ::  theta       !:
+       REAL(wp)     ::  temp        !:
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  usvs  !:
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  vsus  !:
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsus  !:
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsvs  !:
        !$acc declare create ( usvs, vsus, wsus, wsvs )
 
@@ -739,8 +761,8 @@
 !--    ij-version should be called further below within the ij-loops!!
        IF ( topography /= 'flat' )  THEN
-          CALL wall_fluxes_e_acc( usvs, 1.0, 0.0, 0.0, 0.0, wall_e_y )
-          CALL wall_fluxes_e_acc( wsvs, 0.0, 0.0, 1.0, 0.0, wall_e_y )
-          CALL wall_fluxes_e_acc( vsus, 0.0, 1.0, 0.0, 0.0, wall_e_x )
-          CALL wall_fluxes_e_acc( wsus, 0.0, 0.0, 0.0, 1.0, wall_e_x )
+          CALL wall_fluxes_e_acc( usvs, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, wall_e_y )
+          CALL wall_fluxes_e_acc( wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, wall_e_y )
+          CALL wall_fluxes_e_acc( vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, wall_e_x )
+          CALL wall_fluxes_e_acc( wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, wall_e_x )
        ENDIF
 
@@ -823,7 +845,7 @@
 !--                               has been available
 !                            CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-!                                                usvs, 1.0, 0.0, 0.0, 0.0 )
+!                                                usvs, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp )
 !                            CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-!                                                wsvs, 0.0, 0.0, 1.0, 0.0 )
+!                                                wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp )
                             km_neutral = kappa *                                    &
                                         ( usvs(k,j,i)**2 + wsvs(k,j,i)**2 )**0.25 * &
@@ -854,7 +876,7 @@
 !--                               has been available
 !                            CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-!                                                vsus, 0.0, 1.0, 0.0, 0.0 )
+!                                                vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp )
 !                            CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-!                                                wsus, 0.0, 0.0, 0.0, 1.0 )
+!                                                wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp )
                             km_neutral = kappa *                                     &
                                          ( vsus(k,j,i)**2 + wsus(k,j,i)**2 )**0.25 * &
@@ -1350,19 +1372,50 @@
     SUBROUTINE production_e_ij( i, j )
 
-       USE arrays_3d
-       USE cloud_parameters
-       USE control_parameters
-       USE grid_variables
-       USE indices
-       USE statistics
+       USE arrays_3d,                                                          &
+           ONLY:  ddzw, dd2zu, kh, km, pt, q, ql, qsws, qswst, rho, shf,       &
+                  tend, tswst, u, v, vpt, w
+
+       USE cloud_parameters,                                                   &
+           ONLY:  l_d_cp, l_d_r, pt_d_t, t_d_pt
+
+       USE control_parameters,                                                 &
+           ONLY:  cloud_droplets, cloud_physics, g, humidity, kappa, neutral,  &
+                  ocean, prandtl_layer, pt_reference, rho_reference,           &
+                  use_single_reference_value, use_surface_fluxes,              &
+                  use_top_fluxes
+
+       USE grid_variables,                                                     &
+           ONLY:  ddx, dx, ddy, dy, wall_e_x, wall_e_y
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_diff_s_inner,                   &
+                  nzb_diff_s_outer, nzb_s_inner, nzt, nzt_diff
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-
-       REAL    ::  def, dudx, dudy, dudz, dvdx, dvdy, dvdz, dwdx, dwdy, dwdz, &
-                   k1, k2, km_neutral, theta, temp
-
-       REAL, DIMENSION(nzb:nzt+1) ::  usvs, vsus, wsus, wsvs
+       INTEGER(iwp) ::  i           !:
+       INTEGER(iwp) ::  j           !:
+       INTEGER(iwp) ::  k           !:
+
+       REAL(wp)     ::  def         !:
+       REAL(wp)     ::  dudx        !:
+       REAL(wp)     ::  dudy        !:
+       REAL(wp)     ::  dudz        !:
+       REAL(wp)     ::  dvdx        !:
+       REAL(wp)     ::  dvdy        !:
+       REAL(wp)     ::  dvdz        !:
+       REAL(wp)     ::  dwdx        !:
+       REAL(wp)     ::  dwdy        !:
+       REAL(wp)     ::  dwdz        !:
+       REAL(wp)     ::  k1          !:
+       REAL(wp)     ::  k2          !:
+       REAL(wp)     ::  km_neutral  !:
+       REAL(wp)     ::  theta       !:
+       REAL(wp)     ::  temp        !:
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  usvs  !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  vsus  !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsus  !:
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsvs  !:
 
 !
@@ -1427,7 +1480,7 @@
 !--                   validation has been available
                 CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                    usvs, 1.0, 0.0, 0.0, 0.0 )
+                                    usvs, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp )
                 CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                    wsvs, 0.0, 0.0, 1.0, 0.0 )
+                                    wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp )
                 km_neutral = kappa * ( usvs(k)**2 + wsvs(k)**2 )**0.25 * &
                              0.5 * dy
@@ -1457,7 +1510,7 @@
 !--                   validation has been available
                 CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                    vsus, 0.0, 1.0, 0.0, 0.0 )
+                                    vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp )
                 CALL wall_fluxes_e( i, j, k, nzb_diff_s_outer(j,i)-2, &
-                                    wsus, 0.0, 0.0, 0.0, 1.0 )
+                                    wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp )
                 km_neutral = kappa * ( vsus(k)**2 + wsus(k)**2 )**0.25 * & 
                              0.5 * dx
@@ -1840,12 +1893,20 @@
     SUBROUTINE production_e_init
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  kh, km, u, us, usws, v, vsws, zu
+
+       USE control_parameters,                                                 &
+           ONLY:  kappa, prandtl_layer
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxlg, nxr, nxrg, nys, nysg, nyn, nyng, nzb_u_inner,     &
+                  nzb_v_inner
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, ku, kv
+       INTEGER(iwp) ::  i   !:
+       INTEGER(iwp) ::  j   !:
+       INTEGER(iwp) ::  ku  !:
+       INTEGER(iwp) ::  kv  !:
 
        IF ( prandtl_layer )  THEN
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1319)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -87,72 +93,4 @@
 ! temperature equation can be switched off
 !
-! 785 2011-11-28 09:47:19Z raasch
-! new factor rdf_sc allows separate Rayleigh damping of scalars
-!
-! 736 2011-08-17 14:13:26Z suehring
-! Bugfix: determination of first thread index i for WS-scheme
-!
-! 709 2011-03-30 09:31:40Z raasch
-! formatting adjustments
-!
-! 673 2011-01-18 16:19:48Z suehring
-! Consideration of the pressure gradient (steered by tsc(4)) during the time 
-! integration removed.
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Calls of the advection routines with WS5 added.
-! Calls of ws_statistics added to set the statistical arrays to zero after each 
-! time step.
-!
-! 531 2010-04-21 06:47:21Z heinze
-! add call of subsidence in the equation for humidity / passive scalar
-!
-! 411 2009-12-11 14:15:58Z heinze
-! add call of subsidence in the equation for potential temperature
-!
-! 388 2009-09-23 09:40:33Z raasch
-! prho is used instead of rho in diffusion_e,
-! external pressure gradient
-!
-! 153 2008-03-19 09:41:30Z steinfeld
-! add call of plant_canopy_model in the prognostic equation for
-! the potential temperature and for the passive scalar
-!
-! 138 2007-11-28 10:03:58Z letzel
-! add call of subroutines that evaluate the canopy drag terms,
-! add wall_*flux to parameter list of calls of diffusion_s
-!
-! 106 2007-08-16 14:30:26Z raasch
-! +uswst, vswst as arguments in calls of diffusion_u|v,
-! loops for u and v are starting from index nxlu, nysv, respectively (needed
-! for non-cyclic boundary conditions)
-!
-! 97 2007-06-21 08:23:15Z raasch
-! prognostic equation for salinity, density is calculated from equation of
-! state for seawater and is used for calculation of buoyancy,
-! +eqn_state_seawater_mod
-! diffusion_e is called with argument rho in case of ocean runs,
-! new argument zw in calls of diffusion_e, new argument pt_/prho_reference
-! in calls of buoyancy and diffusion_e, calc_mean_pt_profile renamed
-! calc_mean_profile
-!
-! 75 2007-03-22 09:54:05Z raasch
-! checking for negative q and limiting for positive values,
-! z0 removed from arguments in calls of diffusion_u/v/w, uxrp, vynp eliminated,
-! subroutine names changed to .._noopt, .._cache, and .._vector,
-! moisture renamed humidity, Bott-Chlond-scheme can be used in the
-! _vector-version
-!
-! 19 2007-02-23 04:53:48Z raasch
-! Calculation of e, q, and pt extended for gridpoint nzt,
-! handling of given temperature/humidity/scalar fluxes at top surface
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.21  2006/08/04 15:01:07  raasch
-! upstream scheme can be forced to be used for tke (use_upstream_for_tke)
-! regardless of the timestep scheme used for the other quantities,
-! new argument diss in call of diffusion_e
-!
 ! Revision 1.1  2000/04/13 14:56:27  schroeter
 ! Initial revision
@@ -164,38 +102,118 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE eqn_state_seawater_mod
-    USE grid_variables
-    USE indices
-    USE pegrid
-    USE pointer_interfaces
-    USE statistics
-    USE advec_ws
-    USE advec_s_pw_mod
-    USE advec_s_up_mod
-    USE advec_u_pw_mod
-    USE advec_u_up_mod
-    USE advec_v_pw_mod
-    USE advec_v_up_mod
-    USE advec_w_pw_mod
-    USE advec_w_up_mod
-    USE buoyancy_mod
-    USE calc_precipitation_mod
-    USE calc_radiation_mod
-    USE coriolis_mod
-    USE diffusion_e_mod
-    USE diffusion_s_mod
-    USE diffusion_u_mod
-    USE diffusion_v_mod
-    USE diffusion_w_mod
-    USE impact_of_latent_heat_mod
-    USE microphysics_mod
-    USE nudge_mod
-    USE plant_canopy_model_mod
-    USE production_e_mod
-    USE subsidence_mod
-    USE user_actions_mod
+    USE arrays_3d,                                                             &
+        ONLY:  diss_l_e, diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr,            &
+               diss_l_sa, diss_s_e, diss_s_nr, diss_s_pt, diss_s_q,            &
+               diss_s_qr, diss_s_sa, e, e_p, flux_s_e, flux_s_nr, flux_s_pt,   &
+               flux_s_q, flux_s_qr, flux_s_sa, flux_l_e, flux_l_nr,            &
+               flux_l_pt, flux_l_q, flux_l_qr, flux_l_sa, nr, nr_p, nrsws,     &
+               nrswst, pt, ptdf_x, ptdf_y, pt_init, pt_p, prho, q, q_init,     &
+               q_p, qsws, qswst, qr, qr_p, qrsws, qrswst, rdf, rdf_sc, rho,    &
+               sa, sa_init, sa_p, saswsb, saswst, shf, tend, tend_nr,          &
+               tend_pt, tend_q, tend_qr, te_m, tnr_m, tpt_m, tq_m, tqr_m,      &
+               tsa_m, tswst, tu_m, tv_m, tw_m, u, ug, u_p, v, vg, vpt, v_p,    &
+               w, w_p
+        
+    USE control_parameters,                                                    &
+        ONLY:  cloud_physics, constant_diffusion, cthf, dp_external,           &
+               dp_level_ind_b, dp_smooth_factor, dpdxy, dt_3d, humidity,       &
+               icloud_scheme, inflow_l, intermediate_timestep_count,           &
+               intermediate_timestep_count_max, large_scale_subsidence,        &
+               neutral, nudging, ocean, outflow_l, outflow_s, passive_scalar,  &
+               plant_canopy, precipitation, prho_reference, prho_reference,    &
+               prho_reference, pt_reference, pt_reference, pt_reference,       &
+               radiation, scalar_advec, scalar_advec, simulated_time,          &
+               sloping_surface, timestep_scheme, tsc, use_upstream_for_tke,    &
+               use_upstream_for_tke, use_upstream_for_tke, wall_heatflux,      &
+               wall_nrflux, wall_qflux, wall_qflux, wall_qflux, wall_qrflux,   &
+               wall_salinityflux, ws_scheme_mom, ws_scheme_sca
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point
+
+    USE eqn_state_seawater_mod,                                                &
+        ONLY:  eqn_state_seawater
+
+    USE indices,                                                               &
+        ONLY:  i_left, i_right, j_north, j_south, nxl, nxlu, nxr, nyn, nys,    &
+               nysv, nzb_s_inner, nzb_u_inner, nzb_v_inner, nzb_w_inner, nzt
+
+    USE advec_ws,                                                              &
+        ONLY:  advec_s_ws, advec_s_ws_acc, advec_u_ws, advec_u_ws_acc,         &
+               advec_v_ws, advec_v_ws_acc, advec_w_ws, advec_w_ws_acc
+
+    USE advec_s_pw_mod,                                                        &
+        ONLY:  advec_s_pw
+
+    USE advec_s_up_mod,                                                        &
+        ONLY:  advec_s_up
+
+    USE advec_u_pw_mod,                                                        &
+        ONLY:  advec_u_pw
+
+    USE advec_u_up_mod,                                                        &
+        ONLY:  advec_u_up
+
+    USE advec_v_pw_mod,                                                        &
+        ONLY:  advec_v_pw
+
+    USE advec_v_up_mod,                                                        &
+        ONLY:  advec_v_up
+
+    USE advec_w_pw_mod,                                                        &
+        ONLY:  advec_w_pw
+
+    USE advec_w_up_mod,                                                        &
+        ONLY:  advec_w_up
+
+    USE buoyancy_mod,                                                          &
+        ONLY:  buoyancy, buoyancy_acc
+
+    USE calc_precipitation_mod,                                                &
+        ONLY:  calc_precipitation
+
+    USE calc_radiation_mod,                                                    &
+        ONLY:  calc_radiation
+  
+    USE coriolis_mod,                                                          &
+        ONLY:  coriolis, coriolis_acc
+
+    USE diffusion_e_mod,                                                       &
+        ONLY:  diffusion_e, diffusion_e_acc
+
+    USE diffusion_s_mod,                                                       &
+        ONLY:  diffusion_s, diffusion_s_acc
+
+    USE diffusion_u_mod,                                                       &
+        ONLY:  diffusion_u, diffusion_u_acc
+
+    USE diffusion_v_mod,                                                       &
+        ONLY:  diffusion_v, diffusion_v_acc
+
+    USE diffusion_w_mod,                                                       &
+        ONLY:  diffusion_w, diffusion_w_acc
+
+    USE impact_of_latent_heat_mod,                                             &
+        ONLY:  impact_of_latent_heat
+
+    USE kinds
+
+    USE microphysics_mod,                                                      &
+        ONLY:  microphysics_control
+
+    USE nudge_mod,                                                             &
+        ONLY:  nudge
+
+    USE plant_canopy_model_mod,                                                &
+        ONLY:  plant_canopy_model
+
+    USE production_e_mod,                                                      &
+        ONLY:  production_e, production_e_acc
+
+    USE subsidence_mod,                                                        &
+        ONLY:  subsidence
+
+    USE user_actions_mod,                                                      &
+        ONLY:  user_actions
 
 
@@ -235,6 +253,12 @@
     IMPLICIT NONE
 
-    INTEGER ::  i, i_omp_start, j, k, omp_get_thread_num, tn = 0
-    LOGICAL ::  loop_start
+    INTEGER(iwp) ::  i                   !:
+    INTEGER(iwp) ::  i_omp_start         !:
+    INTEGER(iwp) ::  j                   !:
+    INTEGER(iwp) ::  k                   !:
+    INTEGER(iwp) ::  omp_get_thread_num  !:
+    INTEGER(iwp) ::  tn = 0              !:
+    
+    LOGICAL      ::  loop_start          !:
 
 
@@ -835,6 +859,9 @@
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k
-    REAL    ::  sbt
+    INTEGER(iwp) ::  i    !:
+    INTEGER(iwp) ::  j    !:
+    INTEGER(iwp) ::  k    !:
+
+    REAL(wp)     ::  sbt  !:
 
 
@@ -1479,6 +1506,10 @@
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, runge_step
-    REAL    ::  sbt
+    INTEGER(iwp) ::  i           !:
+    INTEGER(iwp) ::  j           !:
+    INTEGER(iwp) ::  k           !:
+    INTEGER(iwp) ::  runge_step  !:
+
+    REAL(wp)     ::  sbt         !:
 
 !
